<?php
/*
 * User-friendly interface to SIEVE server-side mail filtering.
 * Plugin for Squirrelmail 1.2+
 *
 * Copyright (c) 2002 Alexandros Vellis <avel@users.sourceforge.net>
 *
 * Based on Dan Ellis' test scripts that came with sieve-php.lib
 * <danellis@rushmore.com> <URL:http://sieve-php.sourceforge.net>
 *
 * Licensed under the GNU GPL. For full terms see the file COPYING that came
 * with the Squirrelmail distribution.
 *
 */

/* addrule.php: Wizard-like form for adding new rules. */

define('SM_PATH','../../');
require_once(SM_PATH . 'include/validate.php');
require_once(SM_PATH . 'include/load_prefs.php');
require_once(SM_PATH . 'functions/page_header.php');
require_once(SM_PATH . 'functions/imap.php');

include "config.php";
require_once "avelsieve_support.inc.php";
require_once "table_html.php";
require_once "addrule_html.php";
require_once "buildrule.php";
require_once "process_input.php";

if(isset($_GET['edit'])) {
	$edit = $_GET['edit'];
} elseif(isset($_POST['edit'])) {
	$edit = $_POST['edit'];
}

sqsession_is_active();

sqgetGlobalVar('sieve_capabilities', $sieve_capabilities, SQ_SESSION);

if(isset($_POST['append'])) {
	$items = $_POST['items'] + 1;

} elseif(isset($_POST['less'])) {
	$items = $_POST['items'] - 1;

} elseif(isset($_POST['cancel'])) {
	header("Location: table.php");
	exit;

} elseif(isset($_POST['apply'])) {
	// $returnnewrule = urlencode(base64_encode(serialize($sess)));
	$no = $_POST['edit'];
	$type = $_SESSION['rules'][$no]['type'];

	$_SESSION['rules'][$no] = process_input($type);

	/* Communication: */
	$_SESSION['comm']['edited'] = $no;

	header('Location: table.php');
	exit;

} elseif(isset($_POST['addnew'])) {
	// session_unregister('sess');
	// session_unregister('sess');
	// print_r($_POST);
	$no = $_POST['edit'];
	$type = $_SESSION['rules'][$no]['type'];

	$_SESSION['rules'][] = process_input($type);

	/* Communication: */
	$_SESSION['comm']['edited'] = $no;
	$_SESSION['comm']['new'] = true;

	header('Location: table.php');
	exit;
}

/* Just to be safe... */

global $mailboxlist, $edunetmode, $delimiter;

if(isset($_SESSION['delimiter'])) {
	$delimiter = $_SESSION['delimiter'];
} else { /* These aren't likely to be executed.. just in case... */
	$delimiter = sqimap_get_delimiter($imapConnection);
	$_SESSION['delimiter'] = $delimiter;
}


/* Grab the list of my IMAP folders */
// $folder_prefix = "INBOX"; /* Only grab my folders... */
// print "imapConnection = sqimap_login($username, ".$_COOKIE['key'].", $imapServerAddress, $imapPort, 0)"; 
$imapConnection = sqimap_login($username, $_COOKIE['key'], $imapServerAddress, $imapPort, 0); 
$boxes = sqimap_mailbox_list($imapConnection);
sqimap_logout($imapConnection); 

/* Main */

displayPageHeader($color, 'None');
$currentdir = getcwd();

/* Second one (else) is always true, just to check a bit for strange
situations... */

if (defined("SM_PATH")) {
	$prev = bindtextdomain ('avelsieve', SM_PATH . 'plugins/avelsieve/locale');
} elseif (strstr($currentdir, "avelsieve")) {
	$prev = bindtextdomain ('avelsieve', $currentdir.'/locale');
} else {
	$prev = bindtextdomain ('avelsieve', $currentdir.'/avelsieve/locale');
}

textdomain ('avelsieve');

if(!defined('SM_PATH')) {
	chdir ('avelsieve');
}
require_once "constants.php";

if(!defined('SM_PATH')) {
	chdir ('..');
}

// print "<pre>EDIT: "; print_r($_SESSION['rules'][$edit]); print "</pre>";
//print "<pre>DUP: "; print_r($dup); print "</pre>";
//print "<pre>session: "; print_r($_SESSION); print "</pre>";

print '<form action="edit.php" method="POST">
<input type="hidden" name="edit" value="'.$edit.'" />
';

$titlestring =  _("Editing Mail Filtering Rule");
$titlestring .= ' #'. ($edit+1);
printheader2( $titlestring);
print_all_sections_start();

/* Start main */


/* this is for the drop-down box */
switch ($_SESSION['rules'][$edit]['type']) { 
	case 1: 
		print "not implemented yet. :)";
		break;
		
	case 2:			/* header */
		//print "Type: Header match";
		break;		
		
	case 3: 		/* size */
		//print "Type: size match";
		break;
		
	case 4: 		/* All messages */
		//print "Type: all msgs";
		break;
	default:
		print "Debug: no type set.";
		break;
		
}
		
/* --------------------- 'if' ----------------------- */

print_section_start( _("Condition") );

switch ($_SESSION['rules'][$edit]['type']) { 
	case 1: 
		print "not implemented yet. :)";
		break;
		
	case 2:			/* header */
		if(!isset($items)) {
			$items = sizeof($_SESSION['rules'][$edit]['header']) + 1;
			print '<input type="hidden" name="items" value="'.$items.'" />';
		}
		print_2_2_headermatch($items);
		break;		
		
	case 3: 		/* size */
		print_2_3_sizematch();
		break;
		
	case 4: 		/* All messages */
		print_2_4_allmessages();
		break;
		
}
print_section_end();


/* --------------------- 'then' ----------------------- */

print_section_start( _("Action") );

if(isset($_SESSION['rules'][$edit]['folder'])) {
	$selectedmailbox = $_SESSION['rules'][$edit]['folder'];
}

$createnewfolder = false; /* TODO - Remove this and add new folder creation in
edit.php as well. */
print_3_action();

/* End main */
print_section_end();

print '<tr><td><div style="text-align: center">';

if( isset($_GET['dup']) || isset($_POST['dup']) ) {
	print '<input type="hidden" name="dup" value="1" />';
	print '<input type="submit" name="addnew" value="'._("Add New Rule").'" />';
} else {
	print '<input type="submit" name="apply" value="'._("Apply Changes").'" />';
}
print '<input type="submit" name="cancel" value="'._("Cancel").'" />';
print '</div></form></td></tr>';

print_all_sections_end();
printfooter2();

?>
